var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __name = (target, value) => __defProp(target, "name", { value, configurable: true });
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// packages/control/src/index.ts
var src_exports = {};
__export(src_exports, {
  install: () => install,
  using: () => using
});
module.exports = __toCommonJS(src_exports);
var import_path = require("path");

// packages/control/src/authService.ts
var import_zhin = require("zhin");
var import_plugin_console = require("@zhinjs/plugin-console");
var import_plugin_database = require("@zhinjs/plugin-database");
var import_uuid = require("uuid");
var authFields = ["name", "authority", "user_id", "expire", "token"];
function setAuthUser(handle, value) {
  console.log(value);
  handle.user = value;
  handle.send({ type: "data", body: { key: "user", value } });
  handle.refresh();
  return true;
}
__name(setAuthUser, "setAuthUser");
var AuthService = class extends import_plugin_console.DataService {
  constructor(plugin, bot, config) {
    super(bot, "user");
    this.plugin = plugin;
    this.config = config;
    bot.database.extend("User", {
      password: import_plugin_database.DataTypes.STRING,
      token: import_plugin_database.DataTypes.TEXT,
      expire: import_plugin_database.DataTypes.BIGINT
    });
    this.initLogin();
  }
  initLogin() {
    const { bot, config = { loginTokenExpire: import_zhin.Time.minute * 10, authTokenExpire: import_zhin.Time.week } } = this;
    const states = {};
    bot.console.addListener("login/password", async function(user_id, password) {
      const userInstance = await bot.database.model("User").findOne({ where: { user_id }, attributes: ["id", "password", ...authFields] });
      if (!userInstance)
        throw new Error("用户名错误。");
      const user = userInstance.toJSON();
      if (!user || user.password !== password)
        throw new Error("密码错误。");
      if (!user.expire || user.expire < Date.now()) {
        user.token = (0, import_uuid.v4)();
        user.expire = Date.now() + config.authTokenExpire;
        console.log(user);
        await userInstance.update((0, import_zhin.pick)(user, ["token", "expire"]));
      }
      setAuthUser(this, (0, import_zhin.omit)(user, ["password"]));
    });
    bot.console.addListener("login/token", async function(user_id, token) {
      const userInstance = await bot.database.model("User").findOne({ where: { user_id }, attributes: authFields });
      if (!userInstance)
        throw new Error("用户不存在。");
      const user = userInstance.toJSON();
      if (user.token !== token || user.expire <= Date.now())
        throw new Error("令牌已失效。");
      setAuthUser(this, user);
    });
    bot.console.addListener("login/captcha", async function(user_id) {
      const userInstance = await bot.database.model("User").findOne({ where: { user_id } });
      if (!userInstance)
        throw new Error("找不到此账户。");
      const user = userInstance.toJSON();
      const token = (0, import_uuid.v4)();
      const expire = Date.now() + config.loginTokenExpire;
      states[user_id] = [token, expire, this];
      const listener = /* @__PURE__ */ __name(() => {
        delete states[user_id];
        dispose();
        this.socket.removeEventListener("close", listener);
      }, "listener");
      const dispose = bot.setTimeout(() => {
        var _a;
        if (((_a = states[user_id]) == null ? void 0 : _a[1]) >= Date.now())
          listener();
      }, config.loginTokenExpire);
      this.socket.addEventListener("close", listener);
      return { user_id: user.user_id, name: user.name, token, expire };
    });
    bot.middleware(async (session, next) => {
      const state = states[session.user_id];
      if (state && state[0] === session.toCqcode()) {
        const user = session["friend"] || session["member"];
        if (!user.expire || user.expire < Date.now()) {
          user.token = (0, import_uuid.v4)();
          user.expire = Date.now() + config.authTokenExpire;
          await bot.database.model("User").update({ token: (0, import_uuid.v4)(), expire: Date.now() + config.authTokenExpire }, { where: { user_id: user.user_id } });
        }
        return setAuthUser(state[2], user);
      }
      next();
    });
    bot.on("console/intercept", (handle, listener) => {
      if (!listener.authority)
        return false;
      if (!handle.user)
        return true;
      if (handle.user.expire <= Date.now())
        return true;
      return handle.user.authority < listener.authority;
    });
    bot.console.addListener("user/logout", async function() {
      if (!this.user.user_id)
        return;
      delete states[this.user.user_id];
      setAuthUser(this, null);
    });
    bot.console.addListener("user/update", async function(data) {
      if (!this.user)
        throw new Error("请先登录。");
      await bot.database.model("User").update(data, { where: { user_id: this.user.user_id } });
    });
  }
};
__name(AuthService, "AuthService");
AuthService.using = ["console", "database"];

// packages/control/src/index.ts
var import_plugin_console3 = require("@zhinjs/plugin-console");

// packages/control/src/botService.ts
var import_zhin2 = require("zhin");
var import_plugin_console2 = require("@zhinjs/plugin-console");
var Yaml = __toESM(require("js-yaml"));
var import_fs = __toESM(require("fs"));
var TickCounter = class {
  constructor(plugin) {
    this.data = new Array(60).fill(0);
    this.tick = () => {
      this.data.unshift(0);
      this.data.splice(-1, 1);
    };
    const timer = setInterval(() => this.tick(), import_zhin2.Time.second);
    const dispose = /* @__PURE__ */ __name(() => {
      clearInterval(timer);
      return true;
    }, "dispose");
    plugin.disposes.push(this.stop = dispose);
  }
  add(value = 1) {
    this.data[0] += value;
  }
  get() {
    return this.data.reduce((prev, curr) => prev + curr, 0);
  }
};
__name(TickCounter, "TickCounter");
var BotService = class extends import_plugin_console2.DataService {
  constructor(plugin, bot) {
    super(bot, "bot", { authority: 4 });
    this.plugin = plugin;
    this.callbacks = [];
    bot.before("send", (session) => {
      bot._messageSent.add(1);
    });
    bot.on("message", () => {
      bot._messageReceived.add(1);
    });
    BotService.initialize(bot, plugin);
    bot.console.addListener("control/bot-login", (uin, type, value) => {
      return this.loginBot(uin, type, value ? value : void 0);
    }, { authority: 4 });
    bot.console.addListener("control/bot-update", (config) => {
      this.updateBot(config);
    }, { authority: 4 });
    bot.on("system.online", () => {
      this.refresh();
    });
    bot.on("system.offline", () => {
      this.refresh();
    });
    this.extend((bot2) => {
      return {
        ...(0, import_zhin2.pick)(bot2["client"], ["uin", "nickname", "status"]),
        config: bot2.config,
        messageSent: bot2._messageSent.get(),
        messageReceived: bot2._messageReceived.get()
      };
    });
  }
  loginBot(uin, type, value) {
    return new Promise((resolve2, reject) => {
      const disposeArr = [
        this.bot.on("bot.system.online", () => {
          disposeArr.forEach((dispose) => dispose());
          resolve2({ success: true, message: "登录成功", data: "" });
        }),
        this.bot.on("bot.system.login.device", () => {
          disposeArr.forEach((dispose) => dispose());
          this.bot.sendSmsCode();
          resolve2({
            data: "",
            reason: "device",
            success: false,
            message: "收到设备验证，请输入该账号绑定手机收到的验证码"
          });
        }),
        this.bot.on("bot.system.login.qrcode", (session) => {
          disposeArr.forEach((dispose) => dispose());
          resolve2({
            data: `data:image/png;base64,${session.image.toString("base64")}`,
            reason: "qrcode",
            success: false,
            message: "收到登录二维码，请扫码后继续"
          });
        }),
        this.bot.on("bot.system.login.slider", (session) => {
          disposeArr.forEach((dispose) => dispose());
          resolve2({
            data: `请通过下面的url获取ticket后继续
${session.url}`,
            reason: "slider",
            success: false,
            message: "滑块验证"
          });
        }),
        this.bot.on("bot.system.login.error", (session) => {
          disposeArr.forEach((dispose) => dispose());
          resolve2({
            data: session.code,
            reason: session.message,
            success: false,
            message: "登录失败"
          });
        })
      ];
      switch (type) {
        case "password":
          this.bot.login(value);
          break;
        case "slider":
          this.bot.submitSlider(value);
          break;
        case "sms":
          this.bot.submitSmsCode(value);
          break;
        default:
          reject(new Error("无效的类型"));
      }
    });
  }
  updateBot(config) {
    import_fs.default.writeFileSync(Yaml.dump(config), "utf8");
  }
  extend(callback) {
    this.callbacks.push(callback);
  }
  async get() {
    return Object.assign({
      uin: this.bot.uin
    }, ...this.callbacks.map((cb) => cb(this.bot)));
  }
};
__name(BotService, "BotService");
((BotService2) => {
  function initialize(bot, plugin) {
    bot._messageSent = new TickCounter(plugin);
    bot._messageReceived = new TickCounter(plugin);
  }
  BotService2.initialize = initialize;
  __name(initialize, "initialize");
})(BotService || (BotService = {}));

// packages/control/src/index.ts
var using = ["console"];
function install(bot, config = {}) {
  bot.console.addEntry((0, import_path.resolve)(__dirname, "../client/index.ts"));
  bot.service("console.user", new AuthService(this, bot, config));
  bot.service("console.bot", new BotService(this, bot));
}
__name(install, "install");
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  install,
  using
});
//# sourceMappingURL=index.js.map
